> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Odos Swap

> Swap between two tokens using Odos Smart Order Routing.
                    <Info>
                    **Required Allowances**

                        In order to make this transaction, token allowances need to be set for the following contracts.

                     - `OdosRouter`
                    </Info>
                



## OpenAPI

````yaml /v1/combined_spec.json post /v1/swap/odos
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v1/swap/odos:
    post:
      tags:
        - Swap
      summary: Odos Swap
      description: |-
        Swap between two tokens using Odos Smart Order Routing.
                            <Info>
                            **Required Allowances**

                                In order to make this transaction, token allowances need to be set for the following contracts.

                             - `OdosRouter`
                            </Info>
                        
      operationId: v1_swap_odos
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/OdosSwapRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/OdosTransactionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.swap.swap_odos(token_in="0x0000000000000000000000000000000000000000", token_out="USDT", amount_in=0.0001, max_slippage_percent=1, chain=models.OdosSwapRequestChain.ARBITRUM, sender="0xBA5c2548003aDD027489EeDE2C90BE6f1c81cBb9", estimate_gas=True)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.swap.swapOdos({
                tokenIn: "0x0000000000000000000000000000000000000000",
                tokenOut: "USDT",
                amountIn: 0.0001,
                maxSlippagePercent: 1,
                chain: "arbitrum",
                sender: "0xBA5c2548003aDD027489EeDE2C90BE6f1c81cBb9",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    OdosSwapRequest:
      properties:
        action_type:
          type: string
          const: ODOS_SWAP
          title: Action Type
          default: ODOS_SWAP
        token_in:
          type: string
          title: Token
          description: The symbol or address of the token that is to be sold.
          examples:
            - '0xa0b86991c6218b36c1d19d4a2e9eb0ce3606eb48'
          default: '0x0000000000000000000000000000000000000000'
        token_out:
          type: string
          title: Token
          description: The symbol or address of the token that is to be bought.
          examples:
            - '0xdac17f958d2ee523a2206206994597c13d831ec7'
          default: USDT
        amount_in:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount In
          description: The amount of token_in to be sold.
          examples:
            - 1.5
          default: 0.0001
        max_slippage_percent:
          type: number
          maximum: 10
          minimum: 0
          title: Max Slippage Percent
          description: >-
            The maximum slippage allowed in percent. e.g. `1` means `1%`
            slippage allowed.
          examples:
            - 0.5
          default: 1
        chain:
          type: string
          enum:
            - arbitrum
            - base
            - ethereum
          title: Chain
          default: arbitrum
          examples:
            - arbitrum
        sender:
          type: string
          title: Sender
          description: The address of the transaction sender.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0xBA5c2548003aDD027489EeDE2C90BE6f1c81cBb9'
        estimate_gas:
          type: boolean
          title: Estimate Gas
          description: >-
            Determines whether to estimate gas costs for transactions, also
            verifying that the transaction can be successfully executed.
          default: true
      type: object
      required:
        - token_in
        - token_out
        - amount_in
        - max_slippage_percent
        - chain
        - sender
      title: OdosSwapRequest
      default:
        chain: arbitrum
        sender: '0xBA5c2548003aDD027489EeDE2C90BE6f1c81cBb9'
        token_in: '0x0000000000000000000000000000000000000000'
        token_out: USDT
        amount_in: 0.0001
        max_slippage_percent: 1
      required_allowances:
        - OdosRouter
    OdosTransactionResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - $ref: '#/components/schemas/UserOperationResponse'
          title: Transaction
          description: >-
            The unsigned transaction data. User must sign and broadcast to
            network.
        amount_out_quote:
          type: string
          pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount Out Quote
          description: >-
            The estimated amount out for the transaction. The actual output
            amount for this transaction is guaranteed be within the acceptable
            threshold, defined by the `max_slippage_percent`, relative to this
            quote.
      type: object
      required:
        - transaction
        - amount_out_quote
      title: OdosTransactionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    UserOperationResponse:
      properties:
        to:
          type: string
          title: To
          description: The target contract address for the operation
        data:
          type: string
          title: Data
          description: The calldata for the operation
        value:
          type: string
          title: Value
          description: The ETH value to send with the operation
      type: object
      required:
        - to
        - data
        - value
      title: UserOperationResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````